# SwissBorg Technical Challenge: Software Engineer (Data)

Submitted the 18/01/22 for applying to "Software Engineer (Data)"

## Disclaimer

This project intends to provide a solution on the problem described [HERE](https://priceonomics.com/jobs/puzzle/)
with the approach described below.

* The payload received from priceonomics.com is modeled as a directed graph where currencies are the nodes and rates the edges.
* The goal is to find the best arbitrage opportunities between currencies. This could be interpreted as finding a path where the multiplied rates is greater than 1.
* Therefore an arbitrage could be translated as follows:
  * `a * b * ... * n > 1`
  * `< = > log(a * b * ... * n) > log(1)`
  * `< = > log(a) + log(b) + ... + log(n) > log(1)`
  * `< = > log(a) + log(b) + ... + log(n) > 0`
  * `< = > - [log(a) + log(b) + ... + log(n)] < 0`
* This conclusion brings us to the [Bellman-Ford algorithm](https://www.geeksforgeeks.org/bellman-ford-algorithm-dp-23/) which is used to detect negative cycles within a graph
* Coding wise, our graph is implemented as a classic python dictionary

### Algorithm complexity

This algorithm complexity is O(nb of currencies * nb of exchanges rates)

## Getting started

### Prerequisites

1) Running Python 3.7.4 on a virtual environment (from your project root)
    * Install [pyenv](https://realpython.com/intro-to-pyenv/)
    * Run `pyenv virtualenv 3.7.4 NAME_OF_YOUR_VIRTUALENV`
    * Run `pyenv activate NAME_OF_YOUR_VIRTUALENV`
    * Run `pip install --upgrade pip`

2) Install dependencies
   * Run `pip install -r requirements.txt`

### Running project

`python main.py`

### Running tests

Unfortunetely, no unit tests are yet implemented

## Additionnal request

### What is the CHSB

This is an ERC-20 token created by SwissBorg during an ICO in 2017. At that time 1 000 000 000 CHSB tokens where created on the blockchain Ethereum and no more will be created ever.
Therefore SwissBorg did not created its own blockchain neihter its own smart contracts.

This token is defined as "a multi-utility token". This is refering to tokens with the purpose of sustain cryptocrurrencies in general and allowing their owner to interact with the plateform which is creating them. As an example Binance created their own multi-utility token as well.


### CHSB's key features

* CHSB Yield 2.0
  * Improve the rentability of your crypto assets by comparing all the investment opportunities you could benefit from DeFI, CeFI and liquidity pools.
* Community Index
  * It's a scoring system which evaluate the dynamism of the ecosystem and impact the valuation of CHSB.
* Protect & Burn
  * Aim to increase the value of CHSB token by regulation the scarcity of CHSB token. 20% of the ecosystem income is dedicated to "Protect and Burn".
* CHSB Buyback
  * Similarly to Protect and Burn, Swissborg is "removing" (buying)  CHSB from the market to regulate its scarcity and increase its value. Here, this is done on weekly basis, using fees generated by the smart Yield feature. The amount is based on the community index.
* Staking
  * Like a classical staking feature, users could "lock up" their crypto assets for a defined period which is regulating CHSB as well. As a counterparty, users get premium offers.